<template>
  <div class="layout-default">
    <page-header />
    <main>
      <Nuxt />
    </main>
  </div>
</template>

<script>
export default {
  name: 'DefaultLayout',
  data() {
    return {
      routeChangeTimestamp: null,
    };
  },
  mounted() {
      this.$nextTick(() => {
          /* YBUG INIT */
          if (this.$config.YBUG) {
              window.ybug_settings = { id: 'cgr8yttd5n724sn2th5v' };
              const ybug = document.createElement('script');
              ybug.type = 'text/javascript';
              ybug.async = true;
              ybug.src = `https://widget.ybug.io/button/${window.ybug_settings.id}.js`;
              const s = document.getElementsByTagName('script')[0];
              s.parentNode.insertBefore(ybug, s);
          }

          this.$nuxt.$on('routeChanged', this.anchorlinkHandler);
          this.anchorlinkHandler();
      });
  },
  methods: {
    anchorlinkHandler() {
      if (this.$route.hash) {
          setTimeout(() => {
            requestAnimationFrame(this.holdScrollPos);
          }, 250);
        }
    },
    holdScrollPos(timestamp) {
      if (!this.routeChangeTimestamp) {
        this.routeChangeTimestamp = timestamp;
      }

      const hashEl = document.querySelector(this.$route.hash);
      if (hashEl) {
        window.scrollTo(0,hashEl.offsetTop);
      }

      if (timestamp < this.routeChangeTimestamp + 1000) {
        requestAnimationFrame(this.holdScrollPos);
      } else {
        this.routeChangeTimestamp = null;
      }
    },
  },
};
</script>
